select
    'N.: ' || an.numero as numero
    , an.nome
    , (id.anos || ' ano(s) ' || id.meses || ' mes(es) ' || id.dias || ' dia(s)') as idade
    , (select grausangue from sp_calculagrausangue(an.cdanimal)) as "Grau de Sangue"
    , (case cat.cprodutiva
        when 3 then 'Seca'
        when 4 then 'Em Lactao'
        else null end) as "Situacao Produtiva"
    , (case cat.creprodutiva
        when 1 then 'Insem./Cob.'
        when 2 then 'Implant.'
        when 3 then 'Gestante'
        when 4 then 'Vazia' || ': ' || (case cat.sreprodutiva
                                            when 1 then 'Apta'
                                            when 2 then 'Atrasada'
                                            when 3 then 'PEV'
                                            else cat.sreprodutiva end)
        else cat.creprodutiva end) as "Situacao Reprodutiva"
    , 'N.: ' || pai.numero as "Numero Pai"
    , 'N.: ' || mae.numero as "Numero Me"
    , 'N.: ' || paipai.numero as "Numero Av Paterno"
    , 'N.: ' || maepai.numero as "Numero Av Paterna"
    , 'N.: ' || paimae.numero as "Numero Av Materno"
    , 'N.: ' || maemae.numero as "Numero Av Materna"
    , (coalesce((select count (*) from lactacao re1 where re1.cdanimal = an.cdanimal), 0) + coalesce(an.numpartoentrada, 0)) as "Nmero de Lactaes do Animal"
    , (select PRODUCAOTOTAL from sp_calculaproducaototal(l1.cdlactacao, coalesce(l1.dtfim, an.dtbaixa, current_date))) as "Total ltima Lac"
    , (coalesce(l1.dtfim, an.dtbaixa, current_date) - l1.dtinicio) as "Dias ltima Lac"
    , (select PRODUCAOTOTAL from sp_calculaproducaototal(l2.cdlactacao, coalesce(l2.dtfim, an.dtbaixa, current_date))) as "Total Penltima Lac"
    , (coalesce(l2.dtfim, an.dtbaixa, current_date) - l2.dtinicio) as "Dias Penltima Lac"
    , (select PRODUCAOTOTAL from sp_calculaproducaototal(l3.cdlactacao, coalesce(l3.dtfim, an.dtbaixa, current_date))) as "Total Antepenltima Lac"
    , (coalesce(l3.dtfim, an.dtbaixa, current_date) - l3.dtinicio) as "Dias Antepenltima Lac"
    , (select PRODUCAOTOTAL from sp_calculaproducaototal(lac1.cdlactacao, coalesce(lac1.dtfim, mae.dtbaixa, current_date))) as "Lactacao1 Me"
    , (select PRODUCAOTOTAL from sp_calculaproducaototal(lac2.cdlactacao, coalesce(lac2.dtfim, mae.dtbaixa, current_date))) as "Lactacao2 Me"
    , (select PRODUCAOTOTAL from sp_calculaproducaototal(lac3.cdlactacao, coalesce(lac3.dtfim, mae.dtbaixa, current_date))) as "Lactacao3 Me"
    , (select PRODUCAOTOTAL from sp_calculaproducaototal(lac4.cdlactacao, coalesce(lac4.dtfim, mae.dtbaixa, current_date))) as "Lactacao4 Me"
    , (select PRODUCAOTOTAL from sp_calculaproducaototal(lac5.cdlactacao, coalesce(lac5.dtfim, mae.dtbaixa, current_date))) as "Lactacao5 Me"
    , (select PRODUCAOTOTAL from sp_calculaproducaototal(lac6.cdlactacao, coalesce(lac6.dtfim, mae.dtbaixa, current_date))) as "Lactacao6 Me"
    , (select PRODUCAOTOTAL from sp_calculaproducaototal(lac7.cdlactacao, coalesce(lac7.dtfim, mae.dtbaixa, current_date))) as "Lactacao7 Me"
    , (select PRODUCAOTOTAL from sp_calculaproducaototal(lac8.cdlactacao, coalesce(lac8.dtfim, mae.dtbaixa, current_date))) as "Lactacao8 Me"
    , (select PRODUCAOTOTAL from sp_calculaproducaototal(lac9.cdlactacao, coalesce(lac9.dtfim, mae.dtbaixa, current_date))) as "Lactacao9 Me"
    , (select PRODUCAOTOTAL from sp_calculaproducaototal(lac10.cdlactacao, coalesce(lac10.dtfim, mae.dtbaixa, current_date))) as "Lactacao10 Me"
    , (select first 1 re.data from reproducao re where re.cdanimal = an.cdanimal and re.cdtiporeproducao = 7 order by re.data desc) as Ultimo_parto
    , (select first 1 re.data from reproducao re where re.cdanimal = an.cdanimal and re.cdtiporeproducao in (1,2,3) order by re.data desc) as Ultima_IA_COB_TE
    , p4.peso as quarto_ultimo_peso
    , p3.peso as antepenultimo_peso
    , p2.peso as penultimo_peso
    , p1.peso as ultimo_peso
from animal an
    join sp_categoriaanimal (current_date, '') cat on cat.animal = an.cdanimal
    left join animal pai on pai.cdanimal = an.cdpai
    left join animal mae on mae.cdanimal = an.cdmae
    left join animal paipai on paipai.cdanimal = pai.cdpai
    left join animal maepai on maepai.cdanimal = pai.cdmae
    left join animal paimae on paimae.cdanimal = mae.cdpai
    left join animal maemae on maemae.cdanimal = mae.cdmae
    join  sp_idadeanimal ('', 'where cdanimal = ' || an.cdanimal) id on 1=1
    left join lactacao l1 on l1.cdlactacao =
        (select first 1 re.cdlactacao from lactacao re where re.cdanimal = an.cdanimal order by re.dtinicio desc)
    left join lactacao l2 on l2.cdlactacao =
        (select first 1 re.cdlactacao from lactacao re where re.cdanimal = an.cdanimal and re.dtinicio < l1.dtinicio order by re.dtinicio desc)
    left join lactacao l3 on l3.cdlactacao =
        (select first 1 re.cdlactacao from lactacao re where re.cdanimal = an.cdanimal and re.dtinicio < l2.dtinicio order by re.dtinicio desc)
    left join lactacao lac1 on lac1.cdlactacao =
        (select first 1 re.cdlactacao from lactacao re where re.cdanimal = an.cdmae order by re.dtinicio asc)
    left join lactacao lac2 on lac2.cdlactacao =
        (select first 1 re.cdlactacao from lactacao re where re.cdanimal = an.cdmae and re.dtinicio > lac1.dtinicio order by re.dtinicio asc)
    left join lactacao lac3 on lac3.cdlactacao =
        (select first 1 re.cdlactacao from lactacao re where re.cdanimal = an.cdmae and re.dtinicio > lac2.dtinicio order by re.dtinicio asc)
    left join lactacao lac4 on lac4.cdlactacao =
        (select first 1 re.cdlactacao from lactacao re where re.cdanimal = an.cdmae and re.dtinicio > lac3.dtinicio order by re.dtinicio asc)
    left join lactacao lac5 on lac5.cdlactacao =
        (select first 1 re.cdlactacao from lactacao re where re.cdanimal = an.cdmae and re.dtinicio > lac4.dtinicio order by re.dtinicio asc)
    left join lactacao lac6 on lac6.cdlactacao =
        (select first 1 re.cdlactacao from lactacao re where re.cdanimal = an.cdmae and re.dtinicio > lac5.dtinicio order by re.dtinicio asc)
    left join lactacao lac7 on lac7.cdlactacao =
        (select first 1 re.cdlactacao from lactacao re where re.cdanimal = an.cdmae and re.dtinicio > lac6.dtinicio order by re.dtinicio asc)
    left join lactacao lac8 on lac8.cdlactacao =
        (select first 1 re.cdlactacao from lactacao re where re.cdanimal = an.cdmae and re.dtinicio > lac7.dtinicio order by re.dtinicio asc)
    left join lactacao lac9 on lac9.cdlactacao =
        (select first 1 re.cdlactacao from lactacao re where re.cdanimal = an.cdmae and re.dtinicio > lac8.dtinicio order by re.dtinicio asc)
    left join lactacao lac10 on lac10.cdlactacao =
        (select first 1 re.cdlactacao from lactacao re where re.cdanimal = an.cdmae and re.dtinicio > lac9.dtinicio order by re.dtinicio asc)
    left join peso p1 on p1.cdpeso =
        (select first 1 p.cdpeso from peso p where p.cdanimal = an.cdanimal order by p.dtpeso desc)
    left join peso p2 on p2.cdpeso =
        (select first 1 p.cdpeso from peso p where p.cdanimal = an.cdanimal and p.dtpeso < p1.dtpeso order by p.dtpeso desc)
    left join peso p3 on p3.cdpeso =
        (select first 1 p.cdpeso from peso p where p.cdanimal = an.cdanimal and p.dtpeso < p2.dtpeso order by p.dtpeso desc)
    left join peso p4 on p4.cdpeso =
        (select first 1 p.cdpeso from peso p where p.cdanimal = an.cdanimal and p.dtpeso < p3.dtpeso order by p.dtpeso desc)
where
    an.dtbaixa is null
    and an.animalrebanho = 1
    and an.sexo = 'F'
order by
    an.numordenado